/*-------------------------------------------------------------------------
Params provides an experimental setting for exploring reference parameters.

Specification:
	output(screen): the values of 3 variables, Int1, Int2, Int3,
			both before and after the execution of Change().
-------------------------------------------------------------------------*/

#include <iostream.h>

void Change(int, int, int);

void main(void)
{
	// 0. Print a message explaining the program;
	cout << "\nProgram params provides a 'laboratory' in which\n"
		 << "experiments can be performed on parameter-passing.\n";

	int
		Arg1,
		Arg2,
		Arg3;

	// 1. Initialize Arg1, Arg2, and Arg3 to -1;
	Arg1 = Arg2 = Arg3 = -1;

	// 2. Display Arg1, Arg2, and Arg3 (before Change);
	cout << "\nBefore: Arg1 = " << Arg1
		<< ", Arg2 = " << Arg2
		<< ", Arg3 = " << Arg3 << '\n';

	// 3. Call Change, passing it Arg1, Arg2, and Arg3 are arguments;
	Change(Arg1, Arg2, Arg3);

	// 4. Display Arg1, Arg2, and Arg3 (following Change);
	cout << "\nAfter: Arg1 = " << Arg1
		<< ", Arg2 = " << Arg2
		<< ", Arg3 = " << Arg3 << "\n\n";
}

/*------------------------------------------------------------------------
Change is the 'lab' in which we experiment with parameter passing.

Specification:
	receive(caller): 3 integers, stored in A, B, and C;
	return(caller): the (altered ???) values of A, B, and C.
-------------------------------------------------------------------------*/

void Change(int Param1, int Param2, int Param3)
{
	Param1 = 1;
	Param2 = 2;
	Param3 = 3;
}

