/* Decode allows its users to decode a message stored in a file 'decode.dat'
	using the Caesar cipher.

	The encoded message is stored in a file 'encode.dat'.

	Begun by: Joel C. Adams, Spring 1994.
	Completed by:
	Written for: Hands On C++, Lab8.

Specification:
	input(decode.dat): an encoded sequence of characters.
	output(encode.dat): the sequence of decoded input characters.
---------------------------------------------------------------------------*/

#include <iostream.h>  // stream I/O

#include <ctype.h>     // isupper(), tolower()

char CaesarDecode(char Ch);

int main(void)
{
	// 0. Display introductory message
	cout << "\nThis program uses the Caesar cipher to decode"
		 << "\n the contents of a file.  To be decoded,"
		 << "\n the file must be named 'decode.dat'.\n";

	// 1a. Open an fstream named InStream for input to decode.dat
	// 1b. Open an fstream named OutStream for output to encode.dat

	// 2a. If InStream failed to open, display an error message and quit
	// 2b. If OutStream failed to open, display an error message and quit

	char
		Ch;

	// 3. Loop
	for (;;)
	{
		// a. read a character from decode.dat via InStream into Ch

		// b. if end-of-file was reached, terminate repetition

		// c. decode the character using the Caesar cipher
		Ch = CaesarDecode(Ch);

		// d. write the decoded character to encode.dat via OutStream

	}

	// 4a. close the connection to decode.dat
	// 4b. close the connection to encode.dat

	// 5. display a 'successful completion' message
	cout << "\nProcessing complete: decoded message is in 'encode.dat.\n";

	return 0;
}

/*--- CaesarDecode implements the Caesar cipher encoding scheme.

Receive: Ch, a character.
Return: The character that is 3 positions 'before' Ch, if Ch is a letter;
		Ch, otherwise.
-----------------------------------------------------------------------*/

char CaesarDecode(char Ch)
{
	if ((('D' <= Ch) && (Ch <= 'Z')) || // if no wrap-around required
		(('d' <= Ch) && (Ch <= 'z')))
		return (Ch-3);                  //    just add 3 to Ch
	else                                // otherwise if Ch is
		switch(Ch)                      //  one of {x, y, z, X, Y, Z}
		{								//    return the wrap-around char
			case 'A': return 'X';
			case 'B': return 'Y';
			case 'C': return 'Z';
			case 'a': return 'x';
			case 'b': return 'y';
			case 'c': return 'z';
			default: return Ch;
		}
}


