/* Encode allows its users to encode a message stored in a file 'encode.dat'
	using the Caesar cipher.

	The decoded message is stored in a file 'decode.dat'.

	Begun by: Joel C. Adams, Spring 1994.
	Completed by:
	Written for: Hands On C++, Lab8.

Specification:
	input(encode.dat): a sequence of characters.
	output(decode.dat): the sequence of encoded input characters.
---------------------------------------------------------------------------*/

#include <iostream.h>  // stream I/O

#include <ctype.h>     // isupper(), tolower()

char CaesarEncode(char Ch);

int main(void)
{
	// 0. Display introductory message
	cout << "\nThis program uses the Caesar cipher to encode"
		 << "\n the contents of a file.  To be encoded,"
		 << "\n the file must be named 'encode.dat'.\n";

	// 1a. Open an fstream named InStream for input to encode.dat
	// 1b. Open an fstream named OutStream for output to decode.dat

	// 2a. If InStream failed to open, display an error message and quit
	// 2b. If OutStream failed to open, display an error message and quit

	char
		Ch;

	// 3. Loop
	for (;;)
	{
		// a. read a character from encode.dat via InStream into Ch

		// b. if end-of-file was reached, terminate repetition

		// c. encode the character using the Caesar cipher
		Ch = CaesarEncode(Ch);

		// d. write the encoded character to decode.dat via OutStream

	}

	// 4a. close the connection to encode.dat
	// 4b. close the connection to decode.dat

	// 5. display a 'successful completion' message
	cout << "\nProcessing complete: encoded message is in 'decode.dat.\n";

	return 0;
}

/*--- CaesarEncode implements the Caesar cipher encoding scheme.

Receive: Ch, a character.
Return: The character that is 3 positions 'past' Ch, if Ch is a letter;
		Ch, otherwise.
-----------------------------------------------------------------------*/

char CaesarEncode(char Ch)
{
	if ((('A' <= Ch) && (Ch <= 'W')) || // if no wrap-around required
		(('a' <= Ch) && (Ch <= 'w')))
		return (Ch+3);                  //    just add 3 to Ch
	else                                // otherwise if Ch is
		switch(Ch)                      //  one of {x, y, z, X, Y, Z}
		{								//    return the wrap-around char
			case 'X': return 'A';
			case 'Y': return 'B';
			case 'Z': return 'C';
			case 'x': return 'a';
			case 'y': return 'b';
			case 'z': return 'c';
			default: return Ch;
		}
}


