/* Fraction.cc contains the definitions of the Fraction operations,
   as well as any auxillary functions they utilize.

   Begun by: Joel C. Adams, March 1994, at Calvin College.
   Completed by: Joel C. Adams. March 1994 at Calvin College.
-------------------------------------------------------------------*/


// include the Fraction header file here


/*--- Fraction() is the Fraction constructor function.

  Precondition: A Fraction object has been declared.
  Postcondition: Its data members have been initialized.
----------------------------------------------------------------*/

// define the Fraction class constructor here



/*--- operator>> performs the input operation for Fraction objects.

  Receive: In, an istream object,
           Fract, a Fraction object.
  Pass Back: In, with a fraction extracted from it.
             Fract, filled with that fraction.
  Return: In (for chaining).
------------------------------------------------------------------*/

// define operator>> here



/*--- operator<< performs the output operation for Fraction objects.

  Receive: Out, an ostream object,
           Fract, a Fraction object.
  Pass Back: Out, with a fraction inserted onto it.
  Return: Out (for chaining).
------------------------------------------------------------------*/

// define operator<< here




/*--- operator* performs Fraction multiplication.

  Receive: Left and Right, two Fraction operands.
  Return: The Fractional result of multiplying Left and Right.
---------------------------------------------------------------*/

// define operator* here





/* --- GreatestCommonDivisor finds the greatest common divisor
   of two integers, using Euclid's (recursive) algorithm.

   Receive: Alpha, Beta, two integers.
   Return: the greatest common divisor of Alpha and Beta.
---------------------------------------------------------------*/

#include <stdlib.h>  // provides abs()

int GreatestCommonDivisor(int Alpha, int Beta)
{
  Alpha = abs(Alpha);  // take absolute values of operands
  Beta = abs(Beta);

  if (Beta == 0)       // base case
    return Alpha;
  else                 // induction step
    {
//      int Quotient = Alpha / Beta;
      int Remainder = Alpha % Beta;

      return GreatestCommonDivisor(Beta, Remainder);
    }
}

/*--- Simplify() changes a Fraction from improper to proper.

  Receive: The Fraction containing this function
           (as an implicit argument, not an explicit one).
  Return: The Fraction containing this function,
          as a proper fraction.
---------------------------------------------------------------*/

// define Simplify() here

