/* Boolean.cc contains the implementation of those Boolean operations
	that are too complicated to define within class Boolean.

	Written by:
------------------------------------------------------------------------*/

#include "Boolean.h"

/* --- The output operator performs Boolean output.

	Receive: Out, an ostream;
			BoolVal, a Boolean value;
	Output: The character string equivalent to theValue member of BoolVal,
			 onto Out.
	Pass back: Out, with the character string inserted onto it.
	Return: Out, for chaining.
---------------------------------------------------------------*/



/* --- The input operator performs Boolean input.

	Receive: In, an istream;
			BoolVal, a Boolean value;
	Input: A character string, presumed to be True or False.
	Pass back: In, with the character string extracted from it,
				BoolVal, containing the equivalent Boolean_ value
					in its theValue member.
	Return: In, for chaining.
---------------------------------------------------------------*/



/* --- Operator == compares two Boolean objects for equality.

	Receive: Bool1 and Bool2, two Boolean values.
	Return: The Boolean value True, if their theValues members are the same,
				False, otherwise.
-----------------------------------------------------------------*/

Boolean operator==(const Boolean& Bool1, const Boolean& Bool2)
{
	if (Bool1.theValue == Bool2.theValue)
		return True;
	else
		return False;
}




   /* --- Operator != compares two Boolean objects for equality.

	Receive: Bool1 and Bool2, two Boolean values.
	Return: The Boolean value True, if their theValue members are different,
				False, otherwise.
   -----------------------------------------------------------------*/


   /* --- Operator && performs the AND operation on two Booleans.

	Receive: Bool1 and Bool2, two Boolean values.
	Return: The Boolean value True, if both theValue members are True,
				False, otherwise.
   -----------------------------------------------------------------*/



   /* --- Operator || performs the OR operation on two Booleans.

	Receive: Bool1 and Bool2, two Boolean values.
	Return: The Boolean value True, if either theValue member is True,
				False, otherwise.
   -----------------------------------------------------------------*/



   /* --- Operator ! performs the NOT operation on a Boolean.

	Receive: Bool, a Boolean value.
	Return: The Boolean value False, if its theValue member is True,
				True, otherwise.
   -----------------------------------------------------------------*/
