/* Boolean.h contains the declarations needed to implement
	a Boolean data type, using an enumeration.

	Written by:
--------------------------------------------------------------*/




   /*--- The class constructor initializes a Boolean object
	(default value: False).

	Precondition: A Boolean object has been defined.
	Receive: BoolVal, a Boolean_ value (default False).
	Postcondition: theValue is initialized to BoolVal.
   ---------------------------------------------------------------*/



   /* --- This second constructor constructs a Boolean from an int.

	Precondition: An int must be converted to a Boolean.
	Receive: i, an int value.
	Postcondition: If i is equal to zero, then theValue equals False;
					otherwise, theValue equals True.
   ----------------------------------------------------------------*/



   /* --- The output operator performs Boolean output.

	Receive: Out, an ostream;
			BoolVal, a Boolean value;
	Output: The character string equivalent to theValue member of BoolVal,
			 onto Out.
	Pass back: Out, with the character string inserted onto it.
	Return: Out, for chaining.
   ---------------------------------------------------------------*/

   /* --- The input operator performs Boolean input.

	Receive: In, an istream;
			BoolVal, a Boolean value;
	Input: A character string, presumed to be True or False.
	Pass back: In, with the character string extracted from it,
				BoolVal, containing the equivalent Boolean_ value
					in its theValue member.
	Return: In, for chaining.
   ---------------------------------------------------------------*/

   /* --- Operator == compares two Boolean objects for equality.

	Receive: Bool1 and Bool2, two Boolean values.
	Return: The Boolean value True, if their theValues members are the same,
				False, otherwise.
   -----------------------------------------------------------------*/
   friend Boolean operator==(const Boolean& Bool1, const Boolean& Bool2);


   /* --- Operator != compares two Boolean objects for equality.

	Receive: Bool1 and Bool2, two Boolean values.
	Return: The Boolean value True, if their theValue members are different,
				False, otherwise.
   -----------------------------------------------------------------*/


   /* --- Operator && performs the AND operation on two Booleans.

	Receive: Bool1 and Bool2, two Boolean values.
	Return: The Boolean value True, if both theValue members are True,
				False, otherwise.
   -----------------------------------------------------------------*/



   /* --- Operator || performs the OR operation on two Booleans.

	Receive: Bool1 and Bool2, two Boolean values.
	Return: The Boolean value True, if either theValue member is True,
				False, otherwise.
   -----------------------------------------------------------------*/



   /* --- Operator ! performs the NOT operation on a Boolean.

	Receive: Bool, a Boolean value.
	Return: The Boolean value False, if its theValue member is True,
				True, otherwise.
   -----------------------------------------------------------------*/

