/* RealArray.h provides the declarations of class RealArray, an
	array-based class for storing and processing lists of numbers.

	Written by:
	Written for: Hands On C++, Lab 12.
-------------------------------------------------------------------*/






  /* --- The class constructor constructs a RealArray object.

	Precondition: A RealArray object has been declared.
	Receive: Size, the number of elements to be used.
	Postcondition: The object's data members have been initialized
					appropriately as an array of Size values.
  ---------------------------------------------------------------------*/


  /* --- NumValues determines the number of elements in use.

	Receive: A RealArray object.
	Return: The number of elements being used in that object.
  ----------------------------------------------------------------------*/


  /* --- Operator << displays the contents of a RealArray.

	Receive: Out, an ostream object.
			RArray, a RealArray object.
	Output: The values in RArray, onto Out.
	Return(parameters): Out, containing the values of RArray.
	Return(function): Out, for chaining.
  -----------------------------------------------------------------------*/


  /* --- Operator >> fills a RealArray with input values.
	Receive: In, an istream object.
			RArray, a RealArray object.
	Input: A sequence of data values, from In.
	Return(parameters): In, with the input values extracted from it;
						RArray, containing the input values.
	Return(function): In, for chaining.
  -----------------------------------------------------------------------*/



  /* --- LSearch() performs linear search on a RealArray.

	Receive: A RealArray object;
			Val, a data value;
	Return: The index of the element containing Val
			(-1, if Val is not present).
  ----------------------------------------------------------------------*/


  /* --- Operator [] performs the subscript operation on a RealArray.

	Receive: A RealArray object.
			An (unsigned) integer Index.
	Return: A (reference to) the element of theArray whose index is Index.

	Note: Two identical versions of operator[] are provided, one for const
		RealArray objects and one for non-const RealArray objects.
  -----------------------------------------------------------------------*/
