/* LinkList.cc contains the definitions of class LinkedList,
   a list class made up of linked nodes.

   Written by:
   Written for: Hands On C++, Lab 16.
-----------------------------------------------------------------------*/


#include "LinkList.h"

/* --- Operator << provides output for a LinkedList object.

    Receive: Out, an ostream;
			 LList, a LinkedList object;
    Output: The values in LList, onto Out.
    Pass back: Out, containing the output values.
    Return: Out, for chaining.
--------------------------------------------------------------------------*/

// define operator<< here

/* --- Insert() inserts a value into a LinkedList at a given index.

    Receive: A LinkedList;
			 DataVal, a DataType value;
			 Index, an unsigned value.
    Return: The LinkedList object, containing all original values,
			 plus DataVal in the position whose index is Index.
-----------------------------------------------------------------------------------*/

void LinkedList::Insert(DataType DataVal, unsigned Index)
{
  NodePtr
    NPtr = new Node(DataVal);

  NodePtr
    BeforePtr,
    AfterPtr;

  if (Index == 0)
    {
      NPtr->Next = First;
      First = NPtr;
    }
  else if (Index >= NumNodes)
    {
      BeforePtr = First;

      while (BeforePtr->Next != 0)
        BeforePtr = BeforePtr->Next;

      BeforePtr->Next = NPtr;
    }
  else
    {
      BeforePtr = First; AfterPtr = First->Next;

      for (int i = 1; i < Index; i++)
        {
          BeforePtr = BeforePtr->Next;
          AfterPtr = AfterPtr->Next;
        }

      BeforePtr->Next = NPtr;
      NPtr->Next = AfterPtr;
    }

  NumNodes++;
}

/* --- The LinkedList copy constructor makes a copy of a LinkedList.

   Precondition: A copy of a LinkedList is needed.
   Receive: Original, (A reference to) the LinkedList being copied.
   Postcondition: A copy of Original has been constructed.
----------------------------------------------------------------------*/

// define LinkedList copy constructor here



/* --- The Node copy constructor copies a Node and all Nodes that follow it.

   Precondition: A copy of a Node is needed.
   Receive: Original, (A reference to) the Node being copied.
   Postcondition: A copy of Original and each Node following it
                   has been constructed.
--------------------------------------------------------------------*/

// define Node copy constructor here
