/* LinkList.h contains the declarations of class LinkedList,
   a list class made up of linked nodes.

   Written by:
   Written for: Hands On C++, Lab 16.
-----------------------------------------------------------------------*/

#ifndef LINKEDLIST
#define LINKEDLIST

#include <iostream.h>

// declare DataType here

class LinkedList
{
 protected:

  struct Node
    {
				 // define the Data member here

				 // define the link here

      /* --- The Node class constructor initializes a Nodes data members.

         Precondition:  A node has been declared.
         Receive: DataValue, a DataType value;
                        NextValue, a pointer to a Node (default NULL).
         Postcondition: The Data and Next members have been set to
                            DataValue and NextValue, respectively.
	  -------------------------------------------------------------------*/
	  // define Node constructor here

      /* --- The Node destructor reclaims the storage of all Nodes
             following the Node in which it is invoked.

         Precondition: The lifetime of a Node is over.
         Postcondition: It and all following Nodes storage has been reclaimed.
	  --------------------------------------------------------------------*/
	  // define Node destructor here

	  /* --- The Node copy constructor copies a Node and all Nodes that follow it.

         Precondition: A copy of a Node is needed.
		 Receive: Original, (A reference to) the Node being copied.
		 Postcondition: A copy of Original and each Node following it
                   has been constructed.
	  --------------------------------------------------------------------*/
	  Node(const Node& OrigNode);
    };

  typedef Node* NodePtr;

				   // define First here as a pointer to a Node

				   // define NumNodes here

 public:

  /* --- The LinkedList constructor builds an empty LinkedList object.

      Precondition: A LinkedList has been declared.
      Postcondition: Its data members are initialized for an empty list.
   ---------------------------------------------------------------------*/
	// declare class constructor here


   /* --- The LinkedList destructor reclaims its storage.

      Precondition: A LinkedList objects lifetime is over.
      Postcondition: Its storage has been reclaimed.
   --------------------------------------------------------------------*/
  // define LinkedList destructor here

  /* --- The LinkedList copy constructor makes a copy of a LinkedList.

	  Precondition: A copy of a LinkedList is needed.
	  Receive: Original, (A reference to) the LinkedList being copied.
	  Postcondition: A copy of Original has been constructed.
   ----------------------------------------------------------------------*/
  LinkedList(const LinkedList& OrigList);

  /* --- Operator << provides output for a LinkedList object.

      Receive: Out, an ostream;
               LList, a LinkedList object;
      Output: The values in LList, onto Out.
      Pass back: Out, containing the output values.
      Return: Out, for chaining.
  -----------------------------------------------------------------------*/
  // declare operator<< here


  /* --- Insert() inserts a value into a LinkedList at a given index.

      Receive: A LinkedList;
			   DataVal, a DataType value;
			   Index, an unsigned value.
      Return: The LinkedList object, containing all original values,
			   plus DataVal in the position whose index is Index.
  ----------------------------------------------------------------------*/
  // declare Insert() here

};

#endif

